var DLA = {
  ajaxLinkAttrs: {},
  addAjaxSelectBoxAttr:function (attrName, objId, attrDepList, className, formAttrs) {
    if (attrName && attrDepList && className != null) {
        var dep = attrDepList.slice(1, attrDepList.length - 1);
        if (dep && dep != '') {
        var attrDepAr = dep.split(', ');
        var qi = null;
          var title = document.getElementById('title_' + attrName);
          if (title != null && !!title.achdlr) {
            qi = title.achdlr;
          }
        this.ajaxLinkAttrs[attrName] = new this.ajaxSelectBoxAttrData(objId, attrDepAr, className, formAttrs, qi);
        }
      }
  },
  ajaxSelectBoxAttrData:function (objId, attrDepAr, className, formAttrs, qi) {
    this.objId = objId;
    this.attrDepAr = attrDepAr;
    this.className = className;
    if (formAttrs && typeof(formAttrs) == 'object') {
      this.formAttrs = formAttrs;
    }
    this.qi = qi;
  },
  loadAjaxSelectBoxHandlers:function () {
    for (var attrName in this.ajaxLinkAttrs) {
      var objId = this.ajaxLinkAttrs[attrName].objId;
      var attrDepAr = this.ajaxLinkAttrs[attrName].attrDepAr;
      var className = this.ajaxLinkAttrs[attrName].className;
      for (var n = 0; n < attrDepAr.length; n++) {
        this.loadAjaxSelectBox(attrName, attrDepAr, attrDepAr[n], objId, className);
      }
    }
  },
  isCond: function(attrName) {
    for (var item in fieldseditdependence) {
      if (fieldseditdependence.hasOwnProperty(item)) {
        if (fieldseditdependence[item].fld == attrName) {
          return fieldseditdependence[item].cond;
        }
      }
    }
    return false;
  },
  loadAjaxSelectBox:function (attrName, attrDepAr, attrDepAttr, objId, className) {
    var element = document.getElementById('id_' + attrDepAttr);
    if (element) {
      var dl = element.getAttribute("deplist");
      if (dl != null && dl != "") {
        var arr = dl.split(",")
        var i = 0, ct = arr.length
        while (i < ct && arr[i] != attrName) i++
        if (i == ct) {
          arr[arr.length] = attrName
        }
        dl = arr.join(",")
      } else {
        dl = attrName;
      }
      element.setAttribute("deplist", dl);
      var cond = this.isCond(attrName)
      var fun = function () {
        DLA.ajaxLinkAttr(attrName, objId, attrDepAr, className, cond);
      };
      var inputt = document.getElementById('title_' + attrDepAttr);
      if (inputt != null) {
        var qi = inputt.achdlr;
        if (!!qi) {
          // Используется Quick Input
          var after = qi.afterEdit;
          if (after && typeof(after) == 'function') {
            qi.afterEdit = function() {
              after();
              fun();
            };
          } else {
            qi.afterEdit = fun;
          }
        }
      }
      this.addHandler(element, 'change', fun);
      element = document.getElementById('search_' + attrDepAttr);
      if (element) {
        this.addHandler(element, 'click', fun);
        this.addHandler(element, 'keypress', function(event) {
          if (event.keyCode == 13) {
            fun();
          }
        });
      }
    }
  },
  ajaxLinkAttr:function (attrName, objId, depAttrsAr, className, cond) {
    if (DLA.checkEditDependence()) {
      var attr = DLA.ajaxLinkAttrs[attrName];
      if (attr.formAttrs) {
        // Представление default или quick input
        attr.formAttrs = this.getDepLinkAttrs(depAttrsAr);
        if (attr.qi) {
          attr.qi.formAttrs = attr.formAttrs;
          attr.qi.lastResultCache = {};
        }
        var id = document.getElementById("id_" + attrName);
        if (id)
          id.value = '';
        var title = document.getElementById("title_" + attrName);
        if (title)
          title.value = '';
      } else {
        // Представление selectbox
        try {
          var jsonrpc = typeof(jsonrpc) == "undefined" ? new JSONRpcClient(window.getBaseUrl() + "util/ajaxRpc.sx") : jsonrpc;
          var params = DLA.getDepLinkAttrs(depAttrsAr);
          params["attr"] = attrName;
          params["obj_id"] = objId;
          params["class"] = className;
          var ajaxParams = {
            "javaClass": "java.util.HashMap",
            "map": params
          };
          jsonrpc.selectboxrequest.getSelectBoxAttr(function (result) {
            DLA.newSelectBox(result, attrName);
          }, ajaxParams);
        } catch(e) {
        }
      }
    }
  },
  newSelectBox:function (result, attrName) {
    var select = document.getElementById("id_" + attrName);
    if (select) {
      if (select.options) {
        select.options.length = 0;
      }
      DLA.addOption(select, "", "-----");
      if (result != null) {
        var params = result["map"];
        for (var key in params) {
          DLA.addOption(select, key, params[key]);
        }
      }
    }
  },
  addOption: function(select, value, text) {
    if (document.createElement) {
      var option = document.createElement("option");
      option.value = value;
      option.text = text;
    }
    if (select.options && select.options.add) {
      select.options.add(option);
    }
  },
  getDepLinkAttrs:function (depAttrsAr) {
    var params = new Object();
    for (var i = 0; i < depAttrsAr.length; i++) {
      var depAttr = document.getElementById("id_" + depAttrsAr[i]);
      if (depAttr) {
        params[depAttrsAr[i]] = depAttr.value;
      }
    }
    return params;
  },
  addHandler:function (object, event, handler) {
    if (object.addEventListener) {
      object.addEventListener(event, handler, false);
    } else if (object.attachEvent) {
      object.attachEvent('on' + event, handler);
    }
  },

  checkEditDependence : function (attrName) {
    var canEdit = true;
    if (fieldseditdependence[attrName]) {
      for (var i = 0; i < fieldseditdependence[attrName].length; i++) {
        // Для каждого "прослушимаемого" поля
        var fldList = fieldseditdependence[attrName][i].edit;
        if (!fieldseditdependence[attrName][i].cond) {
          canEdit = isCanEdit(fldList)
        } else {
          canEdit = isCanEditOR(fldList)
        }
      }
    }
    return canEdit;
  },

  checkDep:function (attrDepAr, cond) {     //cond - true : хотя бы один из зависимых атрибутов заполнен и этого достаточно
    if (typeof(cond) == "undefined") cond = false;
    for (var n = 0; n < attrDepAr.length; n++) {
      var editCapa = true
      var field = document.getElementById('id_' + attrDepAr[n]);
      var title = document.getElementById('title_' + attrDepAr[n]);
      if (title) {
        if ((!title.checked || title.value == '' || title.value == 'объект не выбран') && (!field || field.value == '' || field.value == 'false')) {
          editCapa = false;
        }
      } else if (!field || field.value == '' || field.value == 'false') {
        editCapa = false;
      }
      if (!editCapa && !cond) return false;
      if (cond && editCapa) return true; //если заполнен хотя бы один, то этого достаточно
    }
    if (cond && !editCapa) return false; // все поля незаполненны
    return true;
  }
};


// Массив, в котором ключом является кодовое имя атрибута,
// а значением список кодовых имен атрибутов, от которых зависит возможность редактирования текущего
var fieldseditdependence = new Array();
var checkDependencesNow = false;  //флаг нахождения в функции проверки зависимостей.... добавлен чтобы проверка не выполнялась параллельно..


// Добавляем новый атрибут для контроля
function addFieldEditDependence(fieldName, dependenceList, cond) {
  var value = dependenceList.slice(1, dependenceList.length - 1);
  if (value && value != '') {
    fieldseditdependence[fieldseditdependence.length] = new editDependence(fieldName, value, cond);
  }
}

// Добавляем скрытое поле - дублер
function addHiddenInput(attrName) {
  var form = self.parent.document.forms['formMain'];
  var inputTag = self.parent.document.getElementById("hid_" + attrName);
  if (form && !inputTag) {
    inputTag = self.parent.document.createElement("INPUT");
    inputTag.setAttribute("type", "hidden");
    inputTag.setAttribute("name", "data(" + attrName + ")");
    inputTag.setAttribute("id", "hid_" + attrName);
    inputTag.setAttribute("value", "");
    form.appendChild(inputTag);
  }
}

// Удаляем скрытое поле - дублер
function removeHiddenInput(attrName) {
  var inputTag = self.parent.document.getElementById("hid_" + attrName);
  if (inputTag) {
    var parent = inputTag.parentNode;
    if (parent) parent.removeChild(inputTag);
  }
}

// Объект, содержащий данные об атрибуте и списке атрибутов, которые надо предварительно заполнить
function editDependence(fieldName, dependenceList, cond) {
  this.fld = fieldName;
  // поля для возможности редактирования
  this.edit = dependenceList.split(', ');
  this.cond = typeof(cond) == "undefined" || cond =="false" ? false : true;
}

// Слушатель полей
function listenEditDependence() {
  if (checkDependencesNow) return;
  checkDependencesNow = true;
  if (fieldseditdependence) {
    for (var i = 0; i < fieldseditdependence.length; i++) {
      // Для каждого "прослушимаемого" поля
      var canEdit = true;
      var fldList = fieldseditdependence[i].edit;
      if (!fieldseditdependence[i].cond) {
        canEdit = isCanEdit(fldList)
      } else {
        canEdit = isCanEditOR(fldList)
      }

      var fld = fieldseditdependence[i].fld;
      var fldId = document.getElementById('id_' + fieldseditdependence[i].fld);
      if (!fldId || (fldId.tagName.toLowerCase() == "input" && fldId.type == "hidden")) {
        fldId = document.getElementById('cal_' + fieldseditdependence[i].fld);
      }
      var fldTitle = document.getElementById('title_' + fieldseditdependence[i].fld);
      var fldBtn = document.getElementById('buttons_' + fieldseditdependence[i].fld);
      if (canEdit) {
        // Если все "ведущие" поля заполены - разрешаем редактировать поле
        if (fldId) {
          fldId.removeAttribute('disabled');
          removeHiddenInput(fieldseditdependence[i].fld);
          fldId.readOnly = "";
          if (fldId.type != "checkbox") {
            fldId.className = "";
          }
        }
        if (fldTitle) {
          fldTitle.removeAttribute('disabled');
          fldTitle.readOnly = "";
          if (fldTitle.type != "checkbox") {
            fldTitle.className = "";
          }
        }
        if (fldBtn) fldBtn.style.display = '';
      } else {
        // Если не все "ведущие" поля заполнены - запрещаем редактрование
        if (fldId) {
          fldId.setAttribute('disabled', 'disabled');
          addHiddenInput(fieldseditdependence[i].fld);
          fldId.readOnly = "true";
          if (fldId.type != "checkbox") {
            fldId.className = "disabled";
          }
          fldId.value = '';
        }
        if (fldTitle) {
          fldTitle.setAttribute('disabled', 'disabled');
          fldTitle.readOnly = "true";
          if (fldTitle.type != "checkbox") {
            fldTitle.className = "disabled";
          }
          fldTitle.value = '';
          fldTitle.checked = false;
        }
        if (fldBtn) {
          fldBtn.style.display = 'none';
        }
      }
    }
  }
  checkDependencesNow = false;
}

function isCanEdit(fldList) {
  for (var j = 0; j < fldList.length; j++) {
    // Проверяем заполненность ведущих атрибутов
    var editFldObj = document.getElementById('id_' + fldList[j]);
    var titleEditFldObj = document.getElementById('title_' + fldList[j]);
    if (titleEditFldObj == null && editFldObj == null) {
      checkDependencesNow = false;
      return true;
    }
    if (titleEditFldObj) {
      if ((!titleEditFldObj.checked || titleEditFldObj.value == '' || titleEditFldObj.value == 'объект не выбран')
              && (!editFldObj || editFldObj.value == '' || editFldObj.value == 'false')) {
        return false;
      }
    } else if (editFldObj.value == '' || editFldObj.value == 'false') {
      return false;
    }
  }
  return true;
}
/**
 * В случае, когда допускается заполнение хотя бы одного из зависимых
 * @param fldList список зависимых полей
 */
function isCanEditOR(fldList) {
  for (var j = 0; j < fldList.length; j++) {
    var isCan = true;
    // Проверяем заполненность ведущих атрибутов
    var editFldObj = document.getElementById('id_' + fldList[j]);
    var titleEditFldObj = document.getElementById('title_' + fldList[j]);
    if (titleEditFldObj == null && editFldObj == null) {
      checkDependencesNow = false;
      return;
    }
    if (titleEditFldObj) {
      if ((!titleEditFldObj.checked || titleEditFldObj.value == '' || titleEditFldObj.value == 'объект не выбран')
              && (!editFldObj || editFldObj.value == '' || editFldObj.value == 'false')) {
        isCan = false;
      }
    } else if (editFldObj.value == '' || editFldObj.value == 'false') {
      isCan = false;
    }
    if (isCan) return true
  }
  return isCan
}

function startListenEditDependence() {
  DLA.loadAjaxSelectBoxHandlers();
  listenEditDependence();
  setInterval('listenEditDependence()', 250);
}

// Запускаем слушателя для блокирования
if (document.addEventListener) {
  document.addEventListener("DOMContentLoaded", startListenEditDependence, true);
  //document.addEventListener("load", startListenEditDependence, true);
} else {
  window.attachEvent("onload", startListenEditDependence);
}
